#!/bin/bash

tmpdir=/tmp/mdlbl_$$
mkdir $tmpdir || exit 1

rm -vf disk*.img
rm -vf vmlinuz.*
rm -vf initrd.*

split -b 200000 vmlinuz vmlinuz.
split -b 200000 initrd  initrd.

copy_vmlinuz="copy $( echo vmlinuz.* | sed 's, , +,g' ) vmlinuz"
copy_initrd="copy $( echo initrd.* | sed 's, , +,g' ) initrd"

disk=1
while true; do
	gunzip < tpldisk.img.gz > disk${disk}.img
	mount -o loop -t msdos disk${disk}.img $tmpdir
	count=6
	while [ $count -gt 0 ] && read fn; do
		mv $fn $tmpdir; (( count-- ))
	done
	umount $tmpdir
	if [ $count -gt 0 ]; then
		if [ $count -eq 6 ]; then
			rm -f disk${disk}.img
			(( disk-- ))
		fi
		break
	fi
	(( disk++ ))
done < <( ls vmlinuz.* initrd.* )

echo -n '' > loader.bat
for ((i=2; i <= $disk; i++)); do
	echo -e "@echo Please insert disk number $i.\r" >> loader.bat
	echo -e "@pause\r\n@copy a:*.* .\r" >> loader.bat
done
echo -e "@$copy_vmlinuz\r" >> loader.bat
echo -e "@$copy_initrd\r"  >> loader.bat
echo -e "loadlin vmlinuz initrd=initrd root=/dev/ram" \
        "devfs=nocompat init=/linuxrc rw\r" >> loader.bat

for ((i=1; i <= $disk; i++)); do
	mount -o loop -t msdos disk${i}.img $tmpdir
	cp loader.bat $tmpdir/loader.bat
	umount $tmpdir
done

rm -f loader.bat
rmdir $tmpdir
exit 0

